<id>
din1031:MemberColorLink
</id>

<version>
3.0.5a
</version>

<edit file>
$sourcedir/Admin.php
</edit file>

<search for>
						'layout' => array($txt['mods_cat_layout']),
</search for>

<replace>
						'layout' => array($txt['mods_cat_layout']),
						'MemberColorLinks' => array($txt['MemberColorLinkHeadline']),
</replace>

<edit file>
$sourcedir/ManageSettings.php
</edit file>

<search for>
		'layout' => 'ModifyLayoutSettings',
</search for>

<replace>
		'layout' => 'ModifyLayoutSettings',
		'MemberColorLinks' => 'ModifyMemberColorLinksSettings',
</replace>

<search for>
			'layout' => array(
			),
</search for>

<replace>
			'layout' => array(
			),
			'MemberColorLinks' => array(
			),
</replace>

<search for>
function ModifyKarmaSettings($return_config = false)
{
	global $txt, $scripturl, $context, $settings, $sc;
</search for>

<add before>
function ModifyMemberColorLinksSettings($return_config = false)
{
	global $txt, $scripturl, $context, $settings, $sc;

	$config_vars = array(
			// Standard Membercolor?
			array('check', 'MemberColorLink'),
			array('check', 'MemberColorLinkOldSpanStyle'),
		'',
			//Some Stat Settings
			array('check', 'MemberColorLatestMember'),
			array('check', 'MemberColorStats'),
			array('check', 'MemberColorWhoIsOnline'),
		'',
			//Thread and Boardsettings
			array('check', 'MemberColorThreadOwner'),
			array('check', 'MemberColorThreadLastPost'),
			array('check', 'MemberColorThreadChild'),
		'',
			//Birthday and Calendar 
			array('check', 'MemberColorModeratorLinks'),
			array('check', 'MemberColorBoardindex'),
			array('check', 'MemberColorBirthday'),
		'',
			//Some Recent Things
			array('check', 'MemberColorRecentOwner'),
			array('check', 'MemberColorRecentLastPost'),
		'',
			// PM Colors
			array('check', 'MemberColorInbox'),
			array('check', 'MemberColorOutbox'),
		'',
			//Moderation Things :)
			array('check' , 'MemberColorModCenter'),
			array('check' , 'MemberColorIssuePList'),
		'',
			//The Heavy Member Search Option
			array('check' , 'MemberColorAllSearch'),
		'',
			//Guest Color
			array('text', 'MemberColorGuests'),
			//Banned User Color
			array('text', 'MemberColorBanned'),
			//Birthday User Color
			array('text', 'MemberColorBirthdayColor'),
	);

	if ($return_config)
		return $config_vars;

	// Saving?
	if (isset($_GET['save']))
	{
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=featuresettings;sa=MemberColorLinks');
	}

	$context['post_url'] = $scripturl . '?action=admin;area=featuresettings;save;sa=MemberColorLinks';
	$context['settings_title'] = $txt['MemberColorLinkHeadline'];

	prepareDBSettingContext($config_vars);
}
</add before>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
	array loadMemberData(array members, bool is_name = false, string set = 'normal')
</search for>

<replace>
	array load_OnlineColors(array members, bool returnarray = true, bool singleuser = false)
		- This function is for Modcreators who like to color the nicks if the MemberColorLink is installed
		  with this function the user can check if the function exists and load the colors if needed.
		  But please load so many ids as possible at one time, to reduce the database querys.
		  To Check if the function exist use if(!empty($modSettings['MemberColorLinkInstalled'])) {}
		- return a array with follow informations
			array(id_member => array(online_color => '', colored_name => '', colored_link => '');
		- The option single user will only return one user color as array, without id before.
		- chache datas the global $color_profile (only the db data, not the array data above)
		- return "false" on nothing loaded!

	bool/string load_mod_color(bool return = false, string update = null)
		- Store the Moderator Color into the $context['modGroupColor']
		- "return = true" will return this color as string
		- This function use only one time the query to load this color
		- update is for the fast update of the moderator color

	bool compare_birthday(string brtihday)
		- Compare Today with the Birthday, true if today his/her birthday 

	array loadMemberData(array members, bool is_name = false, string set = 'normal')
</replace>

<search for>
	// UTF-8 in regular expressions is unsupported on PHP(win) versions < 4.2.3.
</search for>

<replace>
	//This setting should never chached, it show others that member color link is installed!
	$modSettings['MemberColorLinkInstalled'] = function_exists('load_onlineColors') ? 1 : 0;
	$modSettings['MemberColorLinkVersion'] = '3.0.4';

	// UTF-8 in regular expressions is unsupported on PHP(win) versions < 4.2.3.
</replace>

<search for>
				if (!empty($row['id_moderator']))
					$board_info['moderators'][$row['id_moderator']] = array(
						'id' => $row['id_moderator'],
						'name' => $row['real_name'],
						'href' => $scripturl . '?action=profile;u=' . $row['id_moderator'],
						'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['id_moderator'] . '" title="' . $txt['board_moderator'] . '">' . $row['real_name'] . '</a>'
					);
</search for>

<replace>
				if (!empty($row['id_moderator'])) {
					//Online Color if needed for a Moderator :D, to many ways possible <<
					if(!empty($modSettings['MemberColorModeratorLinks']))
						$onlineColor = load_mod_color(true);
					if(!empty($onlineColor))
						$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_moderator'] . '" title="' . $txt['board_moderator'] . ' ' . $row['real_name'] . '"'.(!empty($modSettings['MemberColorLinkOldSpanStyle']) ? '><span style="color:'.$onlineColor.';">' : ' style="color:'.$onlineColor.';">') . $row['real_name'] . (!empty($modSettings['MemberColorLinkOldSpanStyle']) ? '</span>' : '').'</a>';
					else
						$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_moderator'] . '" title="' . $txt['board_moderator'] . '">' . $row['real_name'] . '</a>';
						
					$board_info['moderators'][$row['id_moderator']] = array(
						'id' => $row['id_moderator'],
						'name' => $row['real_name'],
						'href' => $scripturl . '?action=profile;u=' . $row['id_moderator'],
						'link' => $link
					);
				}
</replace>

<search for>
	global $user_profile, $modSettings, $board_info, $smcFunc;
</search for>

<replace>
	global $user_profile, $modSettings, $board_info, $smcFunc;
	global $color_profile; //This is for Preloaded Data, i will not load it twice you know ;)
</replace>

<search for>
			$loaded_ids[] = $data['id_member'];
			$user_profile[$data['id_member']] = $data;
</search for>

<replace>
			$loaded_ids[] = $data['id_member'];
			$user_profile[$data['id_member']] = $data;
			//Happy Birthday Color to this user :D
			if(!empty($modSettings['MemberColorBirthdayColor']) && !empty($data['birthdate']) && compare_colorBirthdate($data['birthdate'])) {
				$user_profile[$data['id_member']]['post_group_color'] = $modSettings['MemberColorBirthdayColor'];
				$user_profile[$data['id_member']]['member_group_color'] = $modSettings['MemberColorBirthdayColor'];
			}
			//Color Banned user, replace there color... hope they are not moderators ;P?
			if(!empty($modSettings['MemberColorBanned']) && isset($data['is_activated']) && $data['is_activated'] >= 10) {
				$user_profile[$data['id_member']]['post_group_color'] = $modSettings['MemberColorBanned'];
				$user_profile[$data['id_member']]['member_group_color'] = $modSettings['MemberColorBanned'];
			}
			//Memeber Color Link will used Chached Data, too wheee.
			if($set == 'normal' || $set == 'profile') //This are the only sets with the info the mod need.
				$color_profile[$data['id_member']] = array(
					'id_member' => $data['id_member'],
					'real_name' => $data['real_name'],
					'member_group_color' => $user_profile[$data['id_member']]['member_group_color'],		
					'post_group_color' => $user_profile[$data['id_member']]['post_group_color'],		
				);
</replace>

<search for>
			$user_profile[$row['id_member']] = $row;
</search for>

<replace>
			$user_profile[$row['id_member']] = $row;
			//Happy Birthday Color to this user :D
			if(!empty($modSettings['MemberColorBirthdayColor']) && !empty($data['birthdate']) && compare_colorBirthdate($data['birthdate'])) {
				$user_profile[$row['id_member']]['post_group_color'] = $modSettings['MemberColorBirthdayColor'];
				$user_profile[$row['id_member']]['member_group_color'] = $modSettings['MemberColorBirthdayColor'];
			}
			//Color Banned user, replace there color... hope they are not moderators ;P?
			if(!empty($modSettings['MemberColorBanned']) && isset($row['is_activated']) && $row['is_activated'] >= 10) {
				$user_profile[$row['id_member']]['post_group_color'] = $modSettings['MemberColorBanned'];
				$user_profile[$row['id_member']]['member_group_color'] = $modSettings['MemberColorBanned'];
			}
			//Memeber Color Link will used Chached Data, too wheee.
			if($set == 'normal' || $set == 'profile') //This are the only sets with the info the mod need.
				$color_profile[$row['id_member']] = array(
					'id_member' => $row['id_member'],
					'real_name' => $row['real_name'],
					'member_group_color' => $user_profile[$row['id_member']]['member_group_color'],		
					'post_group_color' => $user_profile[$row['id_member']]['post_group_color'],		
				);
</replace>

<search for>
			cache_put_data('moderator_group_info', $row, 480);
</search for>

<replace>
			cache_put_data('moderator_group_info', $row, 480);
			//Chaka i will use this information for later... lower the querys ;)
			if(isset($modSettings['MemberColorLinkModColor']) && $modSettings['MemberColorLinkModColor'] != $row['member_group_color'])
				updateSettings(array('MemberColorLinkModColor' => $row['member_group_color']));
</replace>

<search for>
	$profile = $user_profile[$user];
</search for>

<replace>
	$profile = $user_profile[$user];

	//Prepare some colored Datas :D Member Color Link give some Infos back 8)
	$coloredData = load_onlineColors($user, true, true);	
</replace>

<search for>
		'username' => $profile['member_name'],
		'name' => $profile['real_name'],
</search for>

<replace>
		'username' => $profile['member_name'],
		'name' => $profile['real_name'],
		'colored_name' => $coloredData['colored_name'],
		'online_color' => $coloredData['online_color'],
</replace>

<search for>
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '">' . $profile['real_name'] . '</a>',
</search for>

<replace>
		'link' => $coloredData['colored_link'],
		'colorless_link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '">' . $profile['real_name'] . '</a>',
</replace>

<search for>
// Load a theme, by ID.
</search for>

<replace>
//This is the universial load colors function, can be used by each person who need it :)
//I think it's intressting for mod Creators =D
//SMF 2.0.x Version

function load_onlineColors($users, $returnarray = true, $singleuser = false) {
	global $color_profile, $modSettings, $smcFunc;
	static $color_array;

	//Make something for sure :)
	if(!isset($color_profile))
		$color_profile = array();
	//This will hold the array data for later ;)
	if(!isset($color_array))
		$color_array = array();
	//Set a standard empty array for guest errors ;) (Deleted users, which are not resetet)
	if(!isset($color_profile[0]))
		$color_profile[0] = array('member_group_color' => '', 'post_group_color' => '');
	
	// Can't just look for no users :P.
	if (empty($users))
		return false;

	// Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);
	
	//... SSI can insert empty users :x	
	foreach($users as $k => $u)
		if(empty($u) || $u < 0 || !is_numeric($u))
			unset($users[$k]);

	//Now i will use this as a chache, too
	$loaded_ids = array();
	$all_loaded_ids = array_keys($color_profile);
	//All the users that allready loaded
	$loaded_ids = array_intersect($all_loaded_ids, $users);
	//Now i need only the new users to load
	$users = array_diff($users, $all_loaded_ids);
	
	if(!empty($users)) {
		// Load the data.
		$request = $smcFunc['db_query']('', "
			SELECT
			mem.id_member AS id_member, mem.real_name AS real_name, mem.is_activated AS is_activated,
			mem.birthdate AS birthdate,
			mg.online_color AS member_group_color, IFnull(mg.group_name, '') AS member_group,
			pg.online_color AS post_group_color, IFnull(pg.group_name, '') AS post_group
			FROM {db_prefix}members AS mem
			LEFT JOIN {db_prefix}membergroups AS pg ON (pg.id_group = mem.id_post_group)
			LEFT JOIN {db_prefix}membergroups AS mg ON (mg.id_group = mem.id_group)
			WHERE mem.id_member ".(count($users) == 1 ? " = '" . current($users) . "'" : " IN ('" . implode("', '", $users) . "')"));

		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			$loaded_ids[] = $row['id_member'];
			$color_profile[$row['id_member']] = $row;
			//Happy Birthday Color ;D Hope you love it :D
			if(!empty($modSettings['MemberColorBirthdayColor']) && !empty($row['birthdate']) && compare_colorBirthdate($row['birthdate'])) {
				$color_profile[$row['id_member']]['post_group_color'] = $modSettings['MemberColorBirthdayColor'];
				$color_profile[$row['id_member']]['member_group_color'] = $modSettings['MemberColorBirthdayColor'];
			}
			//Banned User hope it is not a mod ;)
			if(!empty($modSettings['MemberColorBanned']) && isset($row['is_activated']) && $row['is_activated'] >= 10) {
				$color_profile[$row['id_member']]['post_group_color'] = $modSettings['MemberColorBanned'];
				$color_profile[$row['id_member']]['member_group_color'] = $modSettings['MemberColorBanned'];
			}
		}
		$smcFunc['db_free_result']($request);
	}
	
	//Build the Array ;D
	$array = array();
	if(!empty($loaded_ids) && $returnarray == true) {
		global $txt, $scripturl, $board_info;
		foreach($loaded_ids as $id) {
			$mod = false;
			//Rewrite Moderator Color!
			if(isset($board_info['moderators'][$id]) && (empty($color_array[$id]) || !$color_array[$id]['moderator'])) {
				if(isset($color_array[$id]))
					unset($color_array[$id]);
				if(empty($color_profile[$id]['member_group_color']))
					$color_profile[$id]['member_group_color'] = load_mod_color(true);
				$mod = true;
			}
			//Load a prepared Data?
			if(!isset($color_array[$id])) {
				$profile = $color_profile[$id];
				$onlineColor = !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'];
				$color_array[$id] = array(
					'id' => $id,
					'online_color' => $onlineColor,
					'colored_name' => (!empty($onlineColor) ? '<span style="color:'. $onlineColor .';">' : '' ) . $profile['real_name'] . (!empty($onlineColor) ? '</span>' : ''),
					//Make it compatible old and new style
					'colored_link' => (empty($modSettings['MemberColorLinkOldSpanStyle']) ?
						'<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"'.(!empty($onlineColor) ? ' style="color:'.$onlineColor.';"' : '').'>' . $profile['real_name'] .'</a>' :
						'<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '">' . ( !empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<span style="color:'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .';">' : '' ) . $profile['real_name'] . (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '</span>' : '' ).'</a>'),
					'moderator' => $mod,
				);
			}
			$array[$id] =	$color_array[$id]; 
		}	
	}

	//This option return only a single user, i hope you know what you do ;)
	if($singleuser === true)
		$array = current($array);

	//Return that what should returned XD
	return (empty($loaded_ids) ? false : ($returnarray == true ? $array : $loaded_ids));
}

//Load in a fast way the Moderator color... i think i cashe it sometimes...
//$update it's only for me that the mod is fast ;)
function load_mod_color($return = false, $update = null) {
	global $context, $modSettings, $smcFunc;
	
	//Need a update?
	if($update !== null && $return === false) {
		updateSettings(array('MemberColorLinkModColor' => $update));
		return true;
	}

	//This settings is loaded in the loadMemberData
	if(isset($modSettings['MemberColorLinkModColor']) && !isset($context['modGroupColor']))
		$context['modGroupColor'] = $modSettings['MemberColorLinkModColor'];
	
	if(!isset($context['modGroupColor'])) {
		$context['modGroupColor'] = '';
		$modColor = $smcFunc['db_query']('', "
			SELECT online_color AS online_color
			FROM {db_prefix}membergroups
			WHERE ID_GROUP = 3
			LIMIT 1");
		list($context['modGroupColor']) = $smcFunc['db_fetch_row']($modColor);
		$smcFunc['db_free_result']($modColor);
	}

	//Need a update?
	if(!isset($modSettings['MemberColorLinkModColor']))
		updateSettings(array('MemberColorLinkModColor' => $context['modGroupColor']));
	
	$return = (bool) $return;
	return $return ? $context['modGroupColor'] : true;
}

//Compare Birthday, return true on todays brithday
function compare_colorBirthdate($birthday = '') {
	if(empty($birthday))
		return false;
	$d = explode('-',trim($birthday));
	if(count($d) != 3)
		return false;
	return date('md') == date('md', mktime(0,0,0,$d['1'],$d['2'],0)) ? true : false;
}

// Load a theme, by ID.
</replace>

<edit file>
$sourcedir/Subs-BoardIndex.php
</edit file>

<search for>
			if (!empty($row_board['id_moderator']))
			{
</search for>

<replace>
			if (!empty($row_board['id_moderator']))
			{
				//Color the Mods, too...
				if(!empty($modSettings['MemberColorModeratorLinks'])) {
					$context['MemberColor_ID_MEMBER'][$row_board['id_moderator']] = $row_board['id_moderator'];
					if(!empty($row_board['id_cat']))
						$context['MemberColor_ModBoard'][$isChild ? $row_board['id_parent'] : $row_board['id_board']] = array(
							'bid' => ($isChild ? $row_board['id_parent'] : $row_board['id_board']),
							'cat' => (!empty($row_board['id_cat']) ? $row_board['id_cat'] : 0));
				}
</replace>

<search for>
				'link' => $row_board['poster_name'] != '' ? (!empty($row_board['id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['id_member'] . '">' . $row_board['real_name'] . '</a>' : $row_board['real_name']) : $txt['not_applicable'],
</search for>

<replace>
				'link' => $row_board['poster_name'] != '' ? (!empty($row_board['id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['id_member'] . '">' . $row_board['real_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row_board['real_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')) : $txt['not_applicable'],
</replace>

<search for>
		// Provide the href and link.
</search for>

<add before>
		//Some things i need for the Membercolor Link :)
		if (!empty($row_board['id_member']))
			$context['MemberColor_ID_MEMBER'][$row_board['id_member']] = $row_board['id_member'];
		if (!empty($modSettings['MemberColorBoardindex']) && !empty($row_board['id_member'])) {
			$context['MemberColor_board'][$isChild ? $row_board['id_parent'] : $row_board['id_board']] = array(
			'bid' => ($isChild ? $row_board['id_parent'] : $row_board['id_board']),
			'cat' => (!empty($row_board['id_cat']) ? $row_board['id_cat'] : 0));
		}
</add before>

<edit file>
$sourcedir/MessageIndex.php
</edit file>

<search for>
	$context['name'] = $board_info['name'];
	$context['description'] = $board_info['description'];
</search for>

<add before>
	//Set some standard Variables for the MemberColorLink
	$context['MemberColor_ID_MEMBER'] = array();
</add before>

<search for>
	if (!empty($board_info['moderators']))
	{
		foreach ($board_info['moderators'] as $mod)
			$context['link_moderators'][] ='<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt['board_moderator'] . '">' . $mod['name'] . '</a>';
</search for>

<replace>
	if (!empty($board_info['moderators']))
	{
		//I hate it in this way... but what should i do ;)
		if(!empty($modSettings['MemberColorModeratorLinks'])) {
			foreach($board_info['moderators'] as $mod)
				$c[$mod['id']] = $mod['id'];
			$colorDatas = load_onlineColors($c);
			foreach ($board_info['moderators'] as $mod) 
				$context['link_moderators'][] = str_replace($txt['profile_of'], $txt['board_moderator'], $colorDatas[$mod['id']]['colored_link']); 
		}
		else
			foreach ($board_info['moderators'] as $mod)
				$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt['board_moderator'] . '">' . $mod['name'] . '</a>';

		$context['linktree'][count($context['linktree']) - 1]['extra_after'] = ' (' . (count($context['link_moderators']) == 1 ? $txt['moderator'] : $txt['moderators']) . ': ' . implode(', ', $context['link_moderators']) . ')';
</replace>

<search for>
			if (!empty($row['online_color']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" style="color: ' . $row['online_color'] . ';">' . $row['real_name'] . '</a>';
</search for>

<replace>
			if (!empty($row['online_color']) && !empty($modSettings['MemberColorWhoIsOnline']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" style="color: ' . $row['online_color'] . ';">' . $row['real_name'] . '</a>';
</replace>

<search for>
			if (!$pre_query)
				$topic_ids[] = $row['id_topic'];
</search for>

<replace>
			if (!$pre_query)
				$topic_ids[] = $row['id_topic'];

			//I need to collect some IDs for the MemberColor :).
			if (!empty($modSettings['MemberColorThreadOwner']) && !empty($row['first_id_member'])) 
					$context['MemberColor_ID_MEMBER'][$row['first_id_member']] = $row['first_id_member'];
			//Oh i need the Last Post ID, too ;)
			if (!empty($modSettings['MemberColorThreadLastPost']) && !empty($row['last_id_member'])) 
					$context['MemberColor_ID_MEMBER'][$row['last_id_member']] = $row['last_id_member'];
</replace>

<search for>
						'link' => !empty($row['first_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['first_id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_display_name'] . '">' . $row['first_display_name'] . '</a>' : $row['first_display_name']
</search for>

<replace>
						'link' => !empty($row['first_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['first_id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_display_name'] . '">' . $row['first_display_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['first_display_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<search for>
						'link' => !empty($row['last_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['last_id_member'] . '">' . $row['last_display_name'] . '</a>' : $row['last_display_name']
</search for>

<replace>
						'link' => !empty($row['last_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['last_id_member'] . '">' . $row['last_display_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['last_display_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<search for>
			determineTopicClass($context['topics'][$row['id_topic']]);
		}
		$smcFunc['db_free_result']($result);
</search for>

<replace>
			determineTopicClass($context['topics'][$row['id_topic']]);
		}
		$smcFunc['db_free_result']($result);

		//Now let's replace the orginal link to the Color Link ;)
		if (!empty($context['MemberColor_ID_MEMBER'])) {
			$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
			//You are not know what you do ;P Colors allready loaded :D
			if(!empty($modSettings['MemberColorModeratorLinks']) && !empty($context['boards'])) {
				//Okay now... do a heavy serach for moderators... only jokeing... but you know... it look so ugly ;)
				$onlineColor = load_mod_color(true);
				foreach($context['boards'] as $ID_BOARD => $boardid_memcolor) {
					//Reset it :D
					$context['boards'][$ID_BOARD]['link_moderators'] = array();
					global $color_profile;
					foreach($context['boards'][$ID_BOARD]['moderators'] as $moderators) {
						$cmemcolid = $moderators['id'];
						//Replace "Profil of" with "Moderator" ;D
						$link = str_replace($txt['profile_of'], $txt['board_moderator'], $colorDatas[$cmemcolid]['colored_link']); 
						if(empty($colorDatas[$cmemcolid]['online_color']) && !empty($onlineColor))
							$link = '<a href="' . $scripturl . '?action=profile;u=' . $color_profile[$cmemcolid]['id_member'] . '" title="' . $txt['board_moderator'] . ' ' . $color_profile[$cmemcolid]['real_name'] . '"'.(!empty($modSettings['MemberColorLinkOldSpanStyle']) ? '><span style="color:'.$onlineColor.';">' : ' style="color:'.$onlineColor.';">') . $color_profile[$cmemcolid]['real_name'] . (!empty($modSettings['MemberColorLinkOldSpanStyle']) ? '</span>' : '').'</a>';
						//Standard Color ;)
						$context['boards'][$ID_BOARD]['moderators'][$cmemcolid]['link'] = $link;
						//Creat the new list...
						$context['boards'][$ID_BOARD]['link_moderators'][] = $link;
					}
				}
			}

			//Need the Childs some Colors XD
			if (!empty($modSettings['MemberColorThreadChild']) && !empty($context['boards'])) {
				foreach($context['boards'] as $ID_BOARD => $boardid_memcolor) {
					if(empty($context['boards'][$ID_BOARD]['last_post']['member']['id']))
						continue;
					//My Childs need a Member Color ;)
					$cmemcolid = $context['boards'][$ID_BOARD]['last_post']['member']['id'];
					if(!empty($colorDatas[$cmemcolid]['colored_link']))
						$context['boards'][$ID_BOARD]['last_post']['member']['link'] = $colorDatas[$cmemcolid]['colored_link'];
				}
			}
			//The Owner or the Last Post of the thread
			if (!empty($modSettings['MemberColorThreadOwner']) || !empty($modSettings['MemberColorThreadLastPost'])) {
				foreach($topic_ids as $topicid_memcolor) {
					//First the Thread Owner Link
					if (!empty($modSettings['MemberColorThreadOwner'])) {
						$cmemcolid = $context['topics'][$topicid_memcolor]['first_post']['member']['id'];
						if(!empty($colorDatas[$cmemcolid]['colored_link']))
							$context['topics'][$topicid_memcolor]['first_post']['member']['link'] = $colorDatas[$cmemcolid]['colored_link'];
					}
					//Or the Last Post Link ;)
					if (!empty($modSettings['MemberColorThreadLastPost'])) {
						$cmemcolid = $context['topics'][$topicid_memcolor]['last_post']['member']['id'];
						if(!empty($colorDatas[$cmemcolid]['colored_link']))
							$context['topics'][$topicid_memcolor]['last_post']['member']['link'] = $colorDatas[$cmemcolid]['colored_link'];
					}
				}
			}
		}
</replace>

<edit file>
$sourcedir/BoardIndex.php
</edit file>

<search for>
	$context['categories'] = getBoardIndex($boardIndexOptions);
</search for>

<add after>
	//The latest member?
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
		$context['MemberColor_ID_MEMBER'][$modSettings['latestMember']] = $modSettings['latestMember'];

	// Know set the colors for the last post...
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		$cmemcolid = null;

		//So the BoardIndex need colored links
		if (!empty($modSettings['MemberColorBoardindex']) && !empty($context['MemberColor_board'])) {
			foreach($context['MemberColor_board'] as $boardid_memcolor) {
				$cmemcolid = $context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['id'];
				if(!empty($colorDatas[$cmemcolid]['colored_link']))
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['link'] = $colorDatas[$cmemcolid]['colored_link'];
			}
		}

		//You are not know what you do ;P Colors allready loaded :D
		if(!empty($modSettings['MemberColorModeratorLinks']) && !empty($context['MemberColor_ModBoard'])) {
			//Okay now... do a heavy serach for moderators... only jokeing... but you know... it look so ugly ;)
			$onlineColor = load_mod_color(true);
			global $scripturl, $color_profile;
			foreach($context['MemberColor_ModBoard'] as $boardid_memcolor) {
				//Reset it :D
				$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['link_moderators'] = array();
				foreach($context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['moderators'] as $moderators) {
					$cmemcolid = $moderators['id'];
					//Replace "Profil of" with "Moderator" ;D
					$link = str_replace($txt['profile_of'], $txt['board_moderator'], $colorDatas[$cmemcolid]['colored_link']); 
					if(empty($colorDatas[$cmemcolid]['online_color']) && !empty($onlineColor))
						$link = '<a href="' . $scripturl . '?action=profile;u=' . $color_profile[$cmemcolid]['id_member'] . '" title="' . $txt['board_moderator'] . ' ' . $color_profile[$cmemcolid]['real_name'] . '"'.(!empty($modSettings['MemberColorLinkOldSpanStyle']) ? '><span style="color:'.$onlineColor.';">' : ' style="color:'.$onlineColor.';">') . $color_profile[$cmemcolid]['real_name'] . (!empty($modSettings['MemberColorLinkOldSpanStyle']) ? '</span>' : '').'</a>';
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['moderators'][$cmemcolid]['link'] = $link;
					//Creat the new list...
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['link_moderators'][] = $link;
				}
			}
		}
	}
</add after>

<edit file>
$sourcedir/Subs-Calendar.php
</edit file>

<search for>
	$bday = array();
</search for>

<add after>
	$MemberSetColor = false;
	$context['MemberColor_ID_MEMBER'] = array();
</add after>

<search for>
		$bday[$age_year . substr($row['birthdate'], 4)][] = array(
			'id' => $row['id_member'],
			'name' => $row['real_name'],
			'age' => $row['birth_year'] > 4 && $row['birth_year'] <= $age_year ? $age_year - $row['birth_year'] : null,
			'is_last' => false
		);
	}
	$smcFunc['db_free_result']($result);
</search for>

<replace>
		$bday[$age_year . substr($row['birthdate'], 4)][] = array(
			'id' => $row['id_member'],
			'name' => $row['real_name'],
			'age' => $row['birth_year'] > 4 && $row['birth_year'] <= $age_year ? $age_year - $row['birth_year'] : null,
			'is_last' => false
		);

		//I need to collect some IDs for the MemberColor :).
		if (!empty($modSettings['MemberColorBirthday']) && !empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
	}
	$smcFunc['db_free_result']($result);

	//Color the Birthday Links :D
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		$cmemcolid = null;

		//So i need only the colors... hmmm why schould i not use only the $user_profiles for this... (The Calenderlink is diffrent)
		if (!empty($modSettings['MemberColorBirthday'])) {
			if (!empty($bday) && is_array($bday)) {
				foreach ($bday as $memcalkv => $memcalva) {
					foreach ($memcalva as $memcalidkv => $memcalid) {
						if(!empty($colorDatas[$memcalid['id']]['colored_link'])) {
							$bday[$memcalkv][$memcalidkv]['color'] = $colorDatas[$memcalid['id']]['colored_link'];
							$bday[$memcalkv][$memcalidkv]['colored_name'] = $colorDatas[$memcalid['id']]['colored_name'];
						}
					}
				}
			}
		}
	}
</replace>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
	if (!empty($board_info['moderators']))
	{
		// Add a link for each moderator...
		foreach ($board_info['moderators'] as $mod)
			$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt['board_moderator'] . '">' . $mod['name'] . '</a>';
</search for>

<replace>
	if (!empty($board_info['moderators']))
	{
		//I hate it in this way... but what should i do ;)
		if(!empty($modSettings['MemberColorModeratorLinks'])) {
			foreach($board_info['moderators'] as $mod)
				$c[$mod['id']] = $mod['id'];
			$colorDatas = load_onlineColors($c);
			foreach ($board_info['moderators'] as $mod) 
				$context['link_moderators'][] = str_replace($txt['profile_of'], $txt['board_moderator'], $colorDatas[$mod['id']]['colored_link']); 
		}
		else
			foreach ($board_info['moderators'] as $mod)
				$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt['board_moderator'] . '">' . $mod['name'] . '</a>';
</replace>

<search for>
			if (!empty($row['online_color']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" style="color: ' . $row['online_color'] . ';">' . $row['real_name'] . '</a>';
</search for>

<replace>
			if (!empty($row['online_color']) && !empty($modSettings['MemberColorWhoIsOnline']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" style="color: ' . $row['online_color'] . ';">' . $row['real_name'] . '</a>';
</replace>

<search for>
		$memberContext[$message['id_member']]['group'] = $txt['guest_title'];
		$memberContext[$message['id_member']]['link'] = $message['poster_name'];
</search for>

<replace>
		$memberContext[$message['id_member']]['group'] = $txt['guest_title'];
		$memberContext[$message['id_member']]['link'] = (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$message['poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '');
</replace>

<edit file>
$sourcedir/Recent.php
</edit file>

<search for>
				'link' => empty($row['id_first_member']) ? $row['first_poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_first_member'] . '">' . $row['first_poster_name'] . '</a>'
</search for>

<replace>
				'link' => empty($row['first_id_member']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['first_poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['first_id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_poster_name'] . '">' . $row['first_poster_name'] . '</a>'
</replace>

<search for>
				'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
</search for>

<replace>
				'link' => empty($row['id_member']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['poster_name'] . '">' . $row['poster_name'] . '</a>'
</replace>

<search for>
	$counter = $_REQUEST['start'] + 1;
	$context['posts'] = array();
</search for>

<add after>
	$context['MemberColor_ID_MEMBER'] = array();
</add after>

<search for>
		if ($user_info['id'] == $row['id_first_member'])
			$board_ids['own'][$row['id_board']][] = $row['id_msg'];
		$board_ids['any'][$row['id_board']][] = $row['id_msg'];
	}
	$smcFunc['db_free_result']($request);
</search for>

<replace>
		if ($user_info['id'] == $row['id_first_member'])
			$board_ids['own'][$row['id_board']][] = $row['id_msg'];
		$board_ids['any'][$row['id_board']][] = $row['id_msg'];

		//The Thread Owners id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentOwner']) && !empty($row['id_first_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_first_member']] = $row['id_first_member'];
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
	}
	$smcFunc['db_free_result']($request);

	// Know set the colors for the Recent posts...
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		$cmemcolid = null;

		//So Let's Color The Recent Posts ;)
		if (is_array($context['posts'])) {
			foreach($context['posts'] as $postkey => $postid_memcolor) {
				if (!empty($modSettings['MemberColorRecentLastPost'])) {
					$cmemcolid = $postid_memcolor['poster']['id'];
					if(!empty($colorDatas[$cmemcolid]['colored_link']))
						$context['posts'][$postkey]['poster']['link'] = $colorDatas[$cmemcolid]['colored_link'];
				}
				if (!empty($modSettings['MemberColorRecentOwner'])) {
					$cmemcolid = $postid_memcolor['first_poster']['id'];
					if(!empty($colorDatas[$cmemcolid]['colored_link']))
						$context['posts'][$postkey]['first_poster']['link'] = $colorDatas[$cmemcolid]['colored_link'];
				}
			}
		}
	}
</replace>

<search for>
	$context['topics'] = array();
	$topic_ids = array();
</search for>

<add after>
	$context['MemberColor_ID_MEMBER'] = array();
</add after>

<search for>
					'link' => !empty($row['id_first_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_first_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_poster_name'] . '">' . $row['first_poster_name'] . '</a>' : $row['first_poster_name']
</search for>

<replace>
					'link' => !empty($row['first_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['first_id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_poster_name'] . '">' . $row['first_poster_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['first_poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<search for>
					'link' => !empty($row['id_last_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_last_member'] . '">' . $row['last_poster_name'] . '</a>' : $row['last_poster_name']
</search for>

<replace>
					'link' => !empty($row['id_last_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_last_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['last_poster_name'] . '">' . $row['last_poster_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['last_poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<search for>
		determineTopicClass($context['topics'][$row['id_topic']]);
	}
	$smcFunc['db_free_result']($request);
</search for>

<replace>
		//The Thread Owners id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentOwner']) && !empty($row['id_first_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_first_member']] = $row['id_first_member'];
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['id_last_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_last_member']] = $row['id_last_member'];

		determineTopicClass($context['topics'][$row['id_topic']]);
	}
	$smcFunc['db_free_result']($request);

	// Know set the colors for the Recent posts...
	if(!empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		$cmemcolid = null;

		//So Let's Color The Recent Posts ;)
		if (is_array($context['topics']) && !empty($context['topics'])) {
			foreach($context['topics'] as $postkey => $postid_memcolor) {
				if (!empty($modSettings['MemberColorRecentLastPost'])) {
					$cmemcolid = $postid_memcolor['last_post']['member']['id'];
					if(!empty($colorDatas[$cmemcolid]['colored_link']))
						$context['topics'][$postkey]['last_post']['member']['link'] = $colorDatas[$cmemcolid]['colored_link'];
				}
				if (!empty($modSettings['MemberColorRecentOwner'])) {
					$cmemcolid = $postid_memcolor['first_post']['member']['id'];
					if(!empty($colorDatas[$cmemcolid]['colored_link']))
						$context['topics'][$postkey]['first_post']['member']['link'] = $colorDatas[$cmemcolid]['colored_link'];
				}
			}
		}
	}
</replace>

<edit file>
$sourcedir/Subs-Recent.php
</edit file>

<search for>
	$posts = array();
</search for>

<add after>
	$context['MemberColor_ID_MEMBER'] = array();	
</add after>

<search for>
				'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
</search for>

<replace>
				'link' => empty($row['id_member']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['poster_name'] . '">' . $row['poster_name'] . '</a>'
</replace>

<search for>
		);
	}
	$smcFunc['db_free_result']($request);

	return $posts;
}
</search for>

<replace>
		);

		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['id_member']))
				$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
	}
	$smcFunc['db_free_result']($request);

	// Know set the colors for the Recent posts...
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		//So Let's Color The Recent Posts ;)
		if (!empty($modSettings['MemberColorRecentLastPost']) && is_array($posts)) {
			foreach($posts as $postkey => $postid_memcolor) {
				if(!empty($colorDatas[$postid_memcolor['poster']['id']]['colored_link']))
					$posts[$postkey]['poster']['link'] = $colorDatas[$postid_memcolor['poster']['id']]['colored_link'];
			}
		}
	}

	return $posts;
}
</replace>

<edit file>
$sourcedir/PersonalMessage.php
</edit file>

<search for>
	$labelQuery = $context['folder'] != 'sent' ? '
			AND FIND_IN_SET(' . $context['current_label_id'] . ', pmr.labels)' : '';
</search for>

<add after>
	//Correct a Modsettings sometime there is a problem, and load variables if i need them ;).
	$colormodcheck = 'MemberColorInbox';
	if ($context['folder'] != 'sent') $colormodcheck = 'MemberColorOutbox';
	$MemberSetColor = false;
	if (empty($modSettings[$colormodcheck]) && !empty($modSettings['MemberColorLink'])) 
		$modSettings['MemberColorLink'] = null;
	if (!empty($modSettings[$colormodcheck])) {
		$context['MemberColor_ID_MEMBER'] = array();
		$MemberColor_IM_ID = array();
	}
</add after>

<search for>
		}
		$smcFunc['db_free_result']($request);

		// Make sure we don't load unnecessary data.
		if ($context['display_mode'] == 1)
		{
			foreach ($posters as $k => $v)
				if (!in_array($k, $display_pms))
					unset($posters[$k]);
		}

		// Load any users....
		$posters = array_unique($posters);
		if (!empty($posters))
			loadMemberData($posters);
</search for>

<replace>
			if (!empty($row['id_member_to']) && !empty($modSettings[$colormodcheck])) {
				$MemberSetColor = true;
				$posters[] = $row['id_member_to'];
				// Hmmm somehow i must know what i should replace... i hope i do it right...
				$MemberColor_IM_ID[$row['id_pm']][empty($row['bcc']) ? 'to' : 'bcc'][] = $row['id_member_to'];
			}
			elseif (empty($row['id_member_to']) && (!empty($modSettings['MemberColorOutbox']) || !empty($modSettings['MemberColorInbox']))) 
				$MemberColor_IM_ID[$row['id_pm']][empty($row['bcc']) ? 'to' : 'bcc'][] = null;
		}
		$smcFunc['db_free_result']($request);

		// Make sure we don't load unnecessary data.
		if ($context['display_mode'] == 1)
		{
			foreach ($posters as $k => $v)
				if (!in_array($k, $display_pms))
					unset($posters[$k]);
		}

		// Load any users....
		$posters = array_unique($posters);
		if (!empty($posters))
			loadMemberData($posters);

		//So i must correct the link ;) i need only the membercontext for this (a little bit faster)
		if ($MemberSetColor && !empty($MemberColor_IM_ID)) {
			$colorDatas = load_onlineColors($posters);
			//So let's replace the links...
			foreach($MemberColor_IM_ID as $pmid => $pmidarray) {
				if (!empty($pmidarray['to'])) 
					foreach($pmidarray['to'] as $pm_meber_key => $pm_member_id) {
						if(!empty($recipients[$pmid]['to'][$pm_meber_key]) && !empty($colorDatas[$pm_member_id]['colored_link'])) {
							$recipients[$pmid]['to'][$pm_meber_key] = $colorDatas[$pm_member_id]['colored_link'];
						}
					}
				if (!empty($pmidarray['bcc'])) 					
					foreach($pmidarray['bcc']  as $pm_meber_key => $pm_member_id) {
						if(!empty($recipients[$pmid]['bcc'][$pm_meber_key]) && !empty($colorDatas[$pm_member_id]['colored_link'])) {
							$recipients[$pmid]['bcc'][$pm_meber_key] = $colorDatas[$pm_member_id]['colored_link'];
						}
					}
			}
		}
</replace>

<edit file>
$sourcedir/Stats.php
</edit file>

<search for>
	$context['top_posters'] = array();
	$max_num_posts = 1;
</search for>

<add after>
	$context['MemberColor_ID_MEMBER'] = array();
</add after>

<search for>
		if ($max_num_posts < $row_members['posts'])
			$max_num_posts = $row_members['posts'];
</search for>

<add after>
		if (!empty($modSettings['MemberColorStats']) && !empty($row_members['id_member']))
			$context['MemberColor_ID_MEMBER'][$row_members['id_member']] = $row_members['id_member'];
</add after>

<search for>
		if ($max_num_topics < $members[$row_members['id_member']])
			$max_num_topics = $members[$row_members['id_member']];
</search for>

<add after>
		if (!empty($modSettings['MemberColorStats']))
			$context['MemberColor_ID_MEMBER'][$row_members['id_member']] = $row_members['id_member'];
</add after>

<search for>
		if ($max_time_online < $row_members['total_time_logged_in'])
			$max_time_online = $row_members['total_time_logged_in'];
</search for>

<add after>
		if (!empty($modSettings['MemberColorStats']))
			$context['MemberColor_ID_MEMBER'][$row_members['id_member']] = $row_members['id_member'];
</add after>

<search for>
	foreach ($context['top_time_online'] as $i => $member)
		$context['top_time_online'][$i]['time_percent'] = round(($member['seconds_online'] * 100) / $max_time_online);
</search for>

<add after>
	
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
		$context['MemberColor_ID_MEMBER'][$modSettings['latestMember']] = $modSettings['latestMember'];
	
	//Yeah baby give me some colors =).
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		$cmemcolid = null;
		if (!empty($modSettings['MemberColorStats'])) {
			// First the Top Posters =)
			foreach($context['top_posters'] as $key => $value) {
				$cmemcolid = $context['top_posters'][$key]['id'];
				if(!empty($colorDatas[$cmemcolid]['colored_link']))
					$context['top_posters'][$key]['link'] = $colorDatas[$cmemcolid]['colored_link'];
			}
			// First the Top Starter =)		
			foreach($context['top_starters'] as $key => $value) {
				$cmemcolid = $context['top_starters'][$key]['id'];
				if(!empty($colorDatas[$cmemcolid]['colored_link']))
					$context['top_starters'][$key]['link'] = $colorDatas[$cmemcolid]['colored_link'];
			}
			// First the Top Onliner =)				
			foreach($context['top_time_online'] as $key => $value) {
				$cmemcolid = $context['top_time_online'][$key]['id'];
				if(!empty($colorDatas[$cmemcolid]['colored_link']))
					$context['top_time_online'][$key]['link'] = $colorDatas[$cmemcolid]['colored_link'];
			}
		}
		if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember'])) {
			if(!empty($colorDatas[$modSettings['latestMember']]['colored_link']))
				$context['latest_member']['link'] = $colorDatas[$modSettings['latestMember']]['colored_link'];
		}
	}
</add after>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
	// This looks weird, but it's because BoardIndex.php references the variable.
	$context['common_stats']['latest_member'] = array(
		'id' => $modSettings['latestMember'],
		'name' => $modSettings['latestRealName'],
		'href' => $scripturl . '?action=profile;u=' . $modSettings['latestMember'],
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $modSettings['latestMember'] . '">' . $modSettings['latestRealName'] . '</a>',
	);
</search for>

<add after>
	//Latest user need some colors... How could you put this into this file... i hate you... i hope no one read this :P
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember'])) {
		$colorDatas = load_onlineColors($modSettings['latestMember']);
		if(!empty($colorDatas[$modSettings['latestMember']]['colored_link']))
			$context['common_stats']['latest_member']['link'] = $colorDatas[$modSettings['latestMember']]['colored_link'];
	}
</add after>

<edit file>
$sourcedir/Profile-Actions.php
</edit file>

<search for>
		$previous_warnings[] = array(
</search for>

<replace>
		if(!empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
		$previous_warnings[] = array(
</replace>

<search for>
	return $previous_warnings;
</search for>

<replace>
	//Color the Issue List
	global $modSettings;
	if(!empty($modSettings['MemberColorIssuePList']) && !empty($context['MemberColor_ID_MEMBER']) && !empty($previous_warnings)) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		foreach($previous_warnings as $key => $warning) {
			if(!empty($colorDatas[$warning['issuer']['id']]['colored_link'])) {
				$previous_warnings[$key]['issuer']['link'] = $colorDatas[$warning['issuer']['id']]['colored_link'];
			}
		}
	}

	return $previous_warnings;
</replace>

<edit file>
$sourcedir/Groups.php
</edit file>

<search for>
		$context['group']['moderators'][] = array(
</search for>

<replace>
		$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
		$context['group']['moderators'][] = array(
</replace>

<search for>
		if ($row['is_activated'] % 10 != 1)
			$last_online = '<i title="' . $txt['not_activated'] . '">' . $last_online . '</i>';
</search for>

<replace>
		if ($row['is_activated'] % 10 != 1)
			$last_online = '<i title="' . $txt['not_activated'] . '">' . $last_online . '</i>';
		if(!empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
</replace>

<search for>
	// Select the template.
	$context['sub_template'] = 'group_members';
	$context['page_title'] = $txt['membergroups_members_title'] . ': ' . $context['group']['name'];
</search for>

<replace>
	//Color the Groups List ;D
	if(!empty($modSettings['MemberColorModCenter']) && !empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		if(!empty($context['group']['moderators'])) {
			foreach($context['group']['moderators'] as $key => $item) {
				if(!empty($colorDatas[$item['id']]['colored_link'])) {
					$context['group']['moderators'][$key]['name'] = $colorDatas[$item['id']]['colored_name'];
				}
			}
		}
		if(!empty($context['members'])) {
			foreach($context['members'] as $key => $item) {
				if(!empty($colorDatas[$item['id']]['colored_link'])) {
					$context['members'][$key]['name'] = $colorDatas[$item['id']]['colored_link'];
				}
			}
		}
	}

	// Select the template.
	$context['sub_template'] = 'group_members';
	$context['page_title'] = $txt['membergroups_members_title'] . ': ' . $context['group']['name'];
</replace>

<search for>
			$groups[$row['id_group']]['moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['real_name'] . '</a>';
</search for>

<replace>
{
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
			$groups[$row['id_group']]['moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['real_name'] . '</a>';
}
</replace>

<search for>
	return $groups;
</search for>

<replace>
	//Color the Group Moderators
	global $modSettings;
	if(!empty($modSettings['MemberColorModCenter']) && !empty($context['MemberColor_ID_MEMBER']) && !empty($groups)) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		foreach($groups as $gkey => $group) {
			if(!empty($group['moderators'])) {
				foreach($group['moderators'] as $id => $item) {
					if(!empty($colorDatas[$id]['colored_link'])) {
						$groups[$gkey]['moderators'][$id] = $colorDatas[$id]['colored_link'];
					}
				}
			}
		}
	}
	
	return $groups;
</replace>

<search for>
		$group_requests[] = array(
			'id' => $row['id_request'],
</search for>

<replace>
		if(!empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
		$group_requests[] = array(
			'id' => $row['id_request'],
			'id_member' => $row['id_member'],
</replace>

<search for>
	return $group_requests;
</search for>

<replace>
	//Give me some Colors baby ;D
	global $modSettings;
	if(!empty($modSettings['MemberColorModCenter']) && !empty($context['MemberColor_ID_MEMBER']) && !empty($group_requests)) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		foreach($group_requests as $key => $item) {
			if(!empty($colorDatas[$item['id_member']]['colored_link'])) {
				$group_requests[$key]['member_link'] = $colorDatas[$item['id_member']]['colored_link'];
			}
		}
	}

	return $group_requests;
</replace>

<edit file>
$sourcedir/ModerationCenter.php
</edit file>

<search for>
	// Don't run this twice... and don't conflict with the admin bar.
	if (isset($context['admin_area']))
		return;
</search for>

<replace>
	// Don't run this twice... and don't conflict with the admin bar.
	if (isset($context['admin_area']))
		return;

	//Standard Member Color Link Varibale
	if(empty($context['MemberColor_ID_MEMBER']))
		$context['MemberColor_ID_MEMBER'] = array();
</replace>

<search for>
		while ($row = $smcFunc['db_fetch_assoc']($request))
			$watched_users[] = $row;
</search for>

<replace>
		while ($row = $smcFunc['db_fetch_assoc']($request))
			$watched_users[$row['id_member']] = $row;
</replace>

<search for>
	$context['watched_users'] = array();
</search for>

<replace>
	$context['watched_users'] = array();
	//Load Watch Colors :)
	if(!empty($modSettings['MemberColorModCenter']) && !empty($watched_users))
		$colorDatas = load_onlineColors(array_keys($watched_users));
</replace>

<search for>
			'name' => $user['real_name'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $user['id_member'] . '">' . $user['real_name'] . '</a>',
</search for>

<replace>
			'name' => !empty($colorDatas[$user['id_member']]['colored_name']) ? $colorDatas[$user['id_member']]['colored_name'] : $user['real_name'],
			'link' => !empty($colorDatas[$user['id_member']]['colored_link']) ? $colorDatas[$user['id_member']]['colored_link'] : '<a href="' . $scripturl . '?action=profile;u=' . $user['id_member'] . '">' . $user['real_name'] . '</a>',
</replace>

<search for>
	$context['notes'] = array();
</search for>

<replace>
	$context['notes'] = array();
	//Load Colors for the notes
	global $modSettings;
	if(!empty($modSettings['MemberColorModCenter']) && !empty($moderator_notes)) {
		foreach($moderator_notes as $note)
			if(!empty($note['id_member'])) {
				$data[$note['id_member']] = $note['id_member'];
			}
		if(isset($data))
			$colorDatas = load_onlineColors($data);
	}
</replace>

<search for>
				'link' => $note['id_member'] ? ('<a href="' . $scripturl . '?action=profile;u=' . $note['id_member'] . '" title="' . $txt['on'] . ' ' . strip_tags(timeformat($note['log_time'])) . '">' . $note['member_name'] . '</a>') : $note['member_name'],
</search for>

<replace>
				'link' => $note['id_member'] ? (!empty($colorDatas[$note['id_member']]['colored_link']) ? $colorDatas[$note['id_member']]['colored_link'] : ('<a href="' . $scripturl . '?action=profile;u=' . $note['id_member'] . '" title="' . $txt['on'] . ' ' . strip_tags(timeformat($note['log_time'])) . '">' . $note['member_name'] . '</a>')) : $note['member_name'],
</replace>

<search for>
		cache_put_data('reported_posts_' . $cachekey, $reported_posts, 90);
	}

	$context['reported_posts'] = array();
</search for>

<replace>
		cache_put_data('reported_posts_' . $cachekey, $reported_posts, 90);
	}

	$context['reported_posts'] = array();
	//Color some Datas?
	global $modSettings;
	if(!empty($modSettings['MemberColorModCenter']) && !empty($reported_posts)) {
		foreach($reported_posts as $report)
			if(!empty($report['id_author'])) {
				$data[$report['id_author']] = $report['id_author'];
			}
		if(isset($data))
			$colorDatas = load_onlineColors($data);
	}
</replace>

<search for>
				'link' => $row['id_author'] ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_author'] . '">' . $row['author_name'] . '</a>' : $row['author_name'],
</search for>

<replace>
				'link' => $row['id_author'] ? (!empty($colorDatas[$row['id_author']]['colored_link']) ? $colorDatas[$row['id_author']]['colored_link'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_author'] . '">' . $row['author_name'] . '</a>') : $row['author_name'],
</replace>

<search for>
			'time_submitted' => timeformat($row['time_applied']),
		);
</search for>

<replace>
			'time_submitted' => timeformat($row['time_applied']),
		);
		
		//Color the links... can you not do it in a better way... okay i will do it :D
		if(!empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
</replace>

<search for>
	$smcFunc['db_free_result']($request);

	return 'group_requests_block';
</search for>

<replace>
	$smcFunc['db_free_result']($request);

	//Give me some Colors baby ;D
	global $modSettings;
	if(!empty($modSettings['MemberColorModCenter']) && !empty($context['MemberColor_ID_MEMBER']) && !empty($context['group_requests'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		foreach($context['group_requests'] as $key => $item) {
			$id = $context['group_requests'][$key]['member']['id'];
			if(!empty($colorDatas[$id]['colored_link'])) {
				$context['group_requests'][$key]['member']['name'] = $colorDatas[$id]['colored_name'];
				$context['group_requests'][$key]['member']['link'] = $colorDatas[$id]['colored_link'];
			}
		}
	}
	return 'group_requests_block';
</replace>

<search for>
		$report_ids[] = $row['id_report'];
		$context['reports'][$row['id_report']] = array(
</search for>

<replace>
		//Color the links... can you not do it in a better way... okay i will do it :D
		if(!empty($row['id_author']))
			$context['MemberColor_ID_MEMBER'][$row['id_author']] = $row['id_author'];
		$report_ids[] = $row['id_report'];
		$context['reports'][$row['id_report']] = array(
</replace>

<search for>
			$context['reports'][$row['id_report']]['comments'][] = array(
</search for>

<replace>
			//Color the links... can you not do it in a better way... okay i will do it :D
			if(!empty($row['id_member']))
				$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
			$context['reports'][$row['id_report']]['comments'][] = array(
</replace>

<search for>
					'href' => $scripturl . '?action=profile;u=' . $row['id_member'],
				),
			);
		}
		$smcFunc['db_free_result']($request);
	}
</search for>

<replace>
					'href' => $scripturl . '?action=profile;u=' . $row['id_member'],
				),
			);
		}
		$smcFunc['db_free_result']($request);
	}

	//Now go through the comments and Reports :D and color them
	if(!empty($modSettings['MemberColorModCenter']) && !empty($context['MemberColor_ID_MEMBER']) && !empty($context['reports'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		foreach($context['reports'] as $rkey => $report) {
			if(!empty($report['author']['id']) && !empty($colorDatas[$report['author']['id']]['colored_link'])) {
				$context['reports'][$rkey]['author']['link'] = $colorDatas[$report['author']['id']]['colored_link'];
			}
			if(!empty($report['comments'])) {
				foreach($report['comments'] as $ckey => $comment) {
					if(!empty($comment['member']['id']) && !empty($colorDatas[$comment['member']['id']]['colored_link'])) {
						$context['reports'][$rkey]['comments'][$ckey]['member']['link'] = $colorDatas[$comment['member']['id']]['colored_link'];
						$context['reports'][$rkey]['comments'][$ckey]['member']['name'] = $colorDatas[$comment['member']['id']]['colored_name'];
					}
				}
			}
		}
	}
</replace>

<search for>
	$context['report'] = array(
		'id' => $row['id_report'],
</search for>

<replace>
	//Color the links... can you not do it in a better way... okay i will do it :D
	if(!empty($row['id_author']))
		$context['MemberColor_ID_MEMBER'][$row['id_author']] = $row['id_author'];
	$context['report'] = array(
		'id' => $row['id_report'],
</replace>

<search for>
		$context['report']['comments'][] = array(
			'id' => $row['id_comment'],
</search for>

<replace>
		if(!empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
		$context['report']['comments'][] = array(
			'id' => $row['id_comment'],
</replace>

<search for>
		$context['report']['mod_comments'][] = array(
			'id' => $row['id_comment'],
</search for>

<replace>
		if(!empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
		$context['report']['mod_comments'][] = array(
			'id' => $row['id_comment'],
</replace>

<search for>
	// What have the other moderators done to this message?
	require_once($sourcedir . '/Modlog.php');
	require_once($sourcedir . '/Subs-List.php');
	loadLanguage('Modlog');
</search for>

<replace>
	//Now go through the comments and Reports :D and color them
	global $modSettings;
	//I do something in the Dirty way but it will work
	if(!empty($modSettings['MemberColorModCenter']) && !empty($context['report']))
		$context['reports']['single'] = $context['report'];
	
	if(!empty($modSettings['MemberColorModCenter']) && !empty($context['MemberColor_ID_MEMBER']) && !empty($context['reports'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		foreach($context['reports'] as $rkey => $report) {
			if(!empty($report['author']['id']) && !empty($colorDatas[$report['author']['id']]['colored_link'])) {
				$context['reports'][$rkey]['author']['link'] = $colorDatas[$report['author']['id']]['colored_link'];
			}
			if(!empty($report['comments'])) {
				foreach($report['comments'] as $ckey => $comment) {
					if(!empty($comment['member']['id']) && !empty($colorDatas[$comment['member']['id']]['colored_link'])) {
						$context['reports'][$rkey]['comments'][$ckey]['member']['link'] = $colorDatas[$comment['member']['id']]['colored_link'];
						$context['reports'][$rkey]['comments'][$ckey]['member']['name'] = $colorDatas[$comment['member']['id']]['colored_name'];
					}
				}
			}
			if(!empty($report['mod_comments'])) {
				foreach($report['mod_comments'] as $ckey => $comment) {
					if(!empty($comment['member']['id']) && !empty($colorDatas[$comment['member']['id']]['colored_link'])) {
						$context['reports'][$rkey]['mod_comments'][$ckey]['member']['link'] = $colorDatas[$comment['member']['id']]['colored_link'];
						$context['reports'][$rkey]['mod_comments'][$ckey]['member']['name'] = $colorDatas[$comment['member']['id']]['colored_name'];
					}
				}
			}
		}
	}
	//Fix the dirty thing i do ;D
	if(!empty($modSettings['MemberColorModCenter']) && !empty($context['report'])) {
		$context['report'] = $context['reports']['single'];
		unset($context['reports']['single']);
	}

	// What have the other moderators done to this message?
	require_once($sourcedir . '/Modlog.php');
	require_once($sourcedir . '/Subs-List.php');
	loadLanguage('Modlog');
</replace>

<search for>
		$member_posts[$row['id_msg']] = array(
			'id' => $row['id_msg'],
</search for>

<replace>
		//Color for this links?
		if(!empty($row['id_member']))
			$ID_MSG[$row['id_msg']] = $row['id_member'];

		$member_posts[$row['id_msg']] = array(
			'id' => $row['id_msg'],
</replace>

<search for>
	return $member_posts;
</search for>

<replace>
	//Color the Post Datas 8)
	if(!empty($modSettings['MemberColorModCenter']) && !empty($context['MemberColor_ID_MEMBER']) && !empty($ID_MSG)) {
		$colorDatas = load_onlineColors($ID_MSG);
		foreach($ID_MSG as $id_msg => $id_member) {
			if(!empty($id_member) && !empty($colorDatas[$id_member]['colored_link'])) {
				$member_posts[$id_msg]['author_link'] = $colorDatas[$id_member]['colored_link'];
			}
		}
	}	

	return $member_posts;
</replace>

<search for>
	$warnings = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
</search for>

<replace>
	$warnings = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		if(!empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
		if(!empty($row['id_recipient']))
			$context['MemberColor_ID_MEMBER'][$row['id_recipient']] = $row['id_recipient'];
</replace>

<search for>
	return $warnings;
</search for>

<replace>
	//Warning Colors... second time... is one time not enouph?
	if(!empty($modSettings['MemberColorModCenter']) && !empty($context['MemberColor_ID_MEMBER']) && !empty($warnings)) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		foreach($warnings as $wkey => $warning) {
			if(!empty($warning['id_issuer']) && !empty($colorDatas[$warning['id_issuer']]['colored_link'])) {
				$warnings[$wkey]['issuer_link'] = $colorDatas[$warning['id_issuer']]['colored_link'];
			}
			if(!empty($warning['id_recipient']) && !empty($colorDatas[$warning['id_recipient']]['colored_link'])) {
				$warnings[$wkey]['recipient_link'] = $colorDatas[$warning['id_recipient']]['colored_link'];
			}
		}
	}
	return $warnings;
</replace>

<edit file>
$sourcedir/Search.php
</edit file>

<search for>
		$memberContext[$message['id_member']]['link'] = $message['poster_name'];
</search for>

<replace>
		$memberContext[$message['id_member']]['link'] = (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$message['poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '');
</replace>

<search for>
	$output = array_merge($context['topics'][$message['id_msg']], array(
</search for>

<replace>
	//Generate the Started By Search Link... This is not fine, because i need to load each sepperate...
	//Ah and add correct Guest links ;D
	$first_post_link = !empty($message['first_member_id']) ? '<a href="' . $scripturl . '?action=profile;u=' . $message['first_member_id'] . '" title="' . $txt['profile_of'] . ' ' . $message['first_member_name'] . '">' . $message['first_member_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$message['first_member_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '');
	$last_post_link = !empty($message['last_member_id']) ? '<a href="' . $scripturl . '?action=profile;u=' . $message['last_member_id'] . '" title="' . $txt['profile_of'] . ' ' . $message['last_member_name'] . '">' . $message['last_member_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$message['last_member_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '');
	if(!empty($modSettings['MemberColorAllSearch'])) {
		$load = array();
		if(!empty($message['first_member_id']))
			$load[] = $message['first_member_id'];
		if(!empty($message['first_member_id']))
			$load[] = $message['last_member_id'];
		if(!empty($load)) {
			$colorDatas = load_onlineColors($load);
			if(!empty($colorDatas[$message['first_member_id']]['colored_link']))
				$first_post_link = $colorDatas[$message['first_member_id']]['colored_link'];
			if(!empty($colorDatas[$message['last_member_id']]['colored_link']))
				$last_post_link = $colorDatas[$message['last_member_id']]['colored_link'];
		}
	}

	$output = array_merge($context['topics'][$message['id_msg']], array(
</replace>

<search for>
				'link' => !empty($message['first_member_id']) ? '<a href="' . $scripturl . '?action=profile;u=' . $message['first_member_id'] . '" title="' . $txt['profile_of'] . ' ' . $message['first_member_name'] . '">' . $message['first_member_name'] . '</a>' : $message['first_member_name']
</search for>

<replace>
				'link' => $first_post_link
</replace>

<search for>
				'link' => !empty($message['last_member_id']) ? '<a href="' . $scripturl . '?action=profile;u=' . $message['last_member_id'] . '" title="' . $txt['profile_of'] . ' ' . $message['last_member_name'] . '">' . $message['last_member_name'] . '</a>' : $message['last_member_name']
</search for>

<replace>
				'link' => $last_post_link
</replace>

<edit file>
$themedir/BoardIndex.template.php
</edit file>

<search for>
							<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['is_today'] ? '<b>' : '', $member['name'], $member['is_today'] ? '</b>' : '', isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '<br />' : ', ';
</search for>

<replace>
							<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['is_today'] ? '<b>' : '', (!empty($member['colored_name']) ? $member['colored_name'] : $member['name']), $member['is_today'] ? '</b>' : '', isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '' : ', ';
</replace>

<edit file>
$themedir/Calendar.template.php
</edit file>

<search for>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '' : ', ';
</search for>

<replace>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', (!empty($member['colored_name']) ? $member['colored_name'] : $member['name']), isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '' : ', ';
</replace>

<search for>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] || ($count == 10 && $use_js_hide)? '' : ', ';
</search for>

<replace>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', (!empty($member['colored_name']) ? $member['colored_name'] : $member['name']), isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] || ($count == 10 && $use_js_hide) ? '' : ', ';
</replace>

<edit file>
$themedir/Profile.template.php
</edit file>

<search for>
			<h4>', $context['member']['name'], ' <span class="position">', (!empty($context['member']['group']) ? $context['member']['group'] : $context['member']['post_group']), '</span></h4>
</search for>

<replace>
			<h4>', $context['member']['colored_name'], ' <span class="position">', (!empty($context['member']['group']) ? $context['member']['group'] : $context['member']['post_group']), '</span></h4>
</replace>
